﻿/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Public License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Public License, please send an email to 
 * dlr@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Public License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/

using MSAst = System.Linq.Expressions;

namespace Microsoft.Scripting.Debugging.CompilerServices {
    /// <summary>
    /// Implemented by compilers to allow the traceback engine to get additional information.
    /// </summary>
    public interface IDebugCompilerSupport {
        bool DoesExpressionNeedReduction(MSAst.Expression expression);
        MSAst.Expression QueueExpressionForReduction(MSAst.Expression expression);
        bool IsCallToDebuggableLambda(MSAst.Expression expression);
    }
}
